#include <cstdio>

extern int keymap_get_key(int value, int press);

int main(int argc, char **argv)
{
	int ret = 0;
	int i;

	const int input[] =
	{
		54,  /* shift */ /* !!!42!!! */
		23,  /* i */
		30,  /* a */
		100, /* alt */
		16,  /* q */
		1,   /* escape */
		0
		
	};
	const int output[] =
	{
		0,   /* control */
		73,  /* I */
		97,  /* a */
		0,   /* control */
		64,  /* @ */
		-1,  /* escape */
		0
	};

	for(i = 0; input[i]; i++)
	{
		int mapval = keymap_get_key(input[i], 1);
		char out[5], map[5];
		sprintf(out, "[--]");
		sprintf(map, "[--]");
		if(output[i] >= 0)
			for(int j = 0; j < 4; j++)
			{
				char tmp = (output[i] >> (3 - j) * 8) & 0xFF;
				out[j] = (tmp ? tmp : 32);
			}
		if(mapval >= 0)
			for(int j = 0; j < 4; j++)
			{
				char tmp = (mapval >> (3 - j) * 8) & 0xFF;
				map[j] = (tmp ? tmp : 32);
			}
		printf("%i -> %8i:%s (%8i:%s)\n",
			input[i],
			mapval, map,
			output[i], out);
		if(mapval != output[i]) ret++;
	}

	if(ret) fprintf(stderr, "TEST FAILED %i TIMES (out of %i)!\n", ret, i);

	return ret;
}

